package org.emerjoin.mpesa4j.impl;

/**
 * @author Mario Junior.
 */
public enum  ResponseCode {

    SUCCESSFUL("INS-0"), INTERNAL_ERROR("INS-1"),
    TRANSACTION_CANCELLED_BY_CUSTOMER("INS-5"),
    TRANSACTION_FAILED("INS-6"), REQUEST_TIMEOUT("INS-9"),
    DUPLICATE_TRANSACTION("INS-10"), INVALID_SHORTCODE_USED("INS-13"),
    INVALID_REFERENCE_USED("INS-14"), INVALID_AMOUNT_USED("INS-15"), TEMPORARY_OVERLOADING("INS-16"),
    INVALID_TRANSACTION_REFERENCE("INS-17"), INVALID_TRANSACTION_ID("INS-18"), INVALID_3RDPARTY_REF("INS-19"),
    NOT_ALL_PARAMETERS_PROVIDED("INS-20"), PARAMETER_VALIDATIONS_FAILD("INS-21"), INVALID_OPERATION_TYPE("INS-22"),
    UNKNOWN_STATUS("INS-23"), INVALID_INITIATOR_IDENTIFIER("INS-24"), INVALID_SECURITY_CREDENTIAL("INS-25"),
    DIRECT_DEBIT_MISSING("INS-993"), DIRECT_DEBIT_ALREADY_EXISTS("INS-994"), CUSTOMER_PROFILE_HAS_PROBLEMS("INS-995"),
    CUSTOMER_ACCOUNT_STATUS_NOT_ACTIVE("INS-996"), LINKING_TRANSACTION_NOT_FOUND("INS-997"), INVALID_MARKET("INS-998"),
    INITIATOR_AUTHENTICATION_ERROR("INS-2001"), RECEIVER_INVALID("INS-2002"), INSUFFICIENT_BALANCE("INS-2006"),
    INVALID_MSISDN("INS-2051"), LANGUAGE_CODE_INVALID("INS-2057");

    private String value;

    ResponseCode(String value){
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public boolean match(String code){
        return value.equalsIgnoreCase(
                code);
    }

}
